/* tslint:disable */
/**
 * This file was automatically generated by json-schema-to-typescript.
 * DO NOT MODIFY IT BY HAND. Instead, modify the source JSONSchema file,
 * and run json-schema-to-typescript to regenerate this file.
 */

/**
 * JSON schema for reference to VideoMediaEncoding entity based on runtime schema
 */
export type VideoMediaEncodingReference =
  | {
      /**
       * The name of the encoding format (ie. H264_mpeg4)
       */
      Name: string
    }
  | number
/**
 * JSON schema for reference to HttpMediaLocation entity based on runtime schema
 */
export type HttpMediaLocationReference = number
/**
 * JSON schema for reference to JoystreamMediaLocation entity based on runtime schema
 */
export type JoystreamMediaLocationReference =
  | {
      /**
       * Id of the data object in the Joystream runtime dataDirectory module
       */
      dataObjectId: string
    }
  | number
/**
 * JSON schema for reference to MediaLocation entity based on runtime schema
 */
export type MediaLocationReference = number

/**
 * JSON schema for entities based on VideoMedia runtime schema
 */
export interface VideoMediaEntity {
  /**
   * Encoding of the video media object
   */
  encoding:
    | {
        new: VideoMediaEncodingEntity
      }
    | {
        existing: VideoMediaEncodingReference
      }
  /**
   * Video media width in pixels
   */
  pixelWidth: number
  /**
   * Video media height in pixels
   */
  pixelHeight: number
  /**
   * Video media size in bytes
   */
  size?: number
  /**
   * Location of the video media object
   */
  location:
    | {
        new: MediaLocationEntity
      }
    | {
        existing: MediaLocationReference
      }
}
/**
 * JSON schema for entities based on VideoMediaEncoding runtime schema
 */
export interface VideoMediaEncodingEntity {
  /**
   * The name of the encoding format (ie. H264_mpeg4)
   */
  Name: string
}
/**
 * JSON schema for entities based on MediaLocation runtime schema
 */
export interface MediaLocationEntity {
  /**
   * A reference to HttpMediaLocation
   */
  httpMediaLocation?:
    | {
        new: HttpMediaLocationEntity
      }
    | {
        existing: HttpMediaLocationReference
      }
  /**
   * A reference to JoystreamMediaLocation
   */
  joystreamMediaLocation?:
    | {
        new: JoystreamMediaLocationEntity
      }
    | {
        existing: JoystreamMediaLocationReference
      }
}
/**
 * JSON schema for entities based on HttpMediaLocation runtime schema
 */
export interface HttpMediaLocationEntity {
  /**
   * The http url pointing to the media
   */
  url: string
  /**
   * The port to use when connecting to the http url (defaults to 80)
   */
  port?: number
}
/**
 * JSON schema for entities based on JoystreamMediaLocation runtime schema
 */
export interface JoystreamMediaLocationEntity {
  /**
   * Id of the data object in the Joystream runtime dataDirectory module
   */
  dataObjectId: string
}
